﻿#region using Directives
using System;
using System.Xml;
using System.Windows;
using System.Collections.Generic;
using Selectron_C_Bus_Calculator.ViewModel;
#endregion

namespace Selectron_C_Bus_Calculator.Model
{
    public class StartupPsm12Ex : BaseViewModel
    {
        #region Variables
        //This Public Dictionary is for saving all the Nodes
        public Dictionary<string, Nodes> Nodes = new Dictionary<string, Nodes>();
        #endregion

        #region Instances
        //Initialise other Classes
        private readonly XmlDocument _doc = new XmlDocument();
        private PowerCalculatorViewModel _pcvm;
        #endregion

        public void Startup(PowerCalculatorViewModel pcvm)
        {
            #region Load XMl File
            _pcvm = pcvm;

            //Try to Load the XML File 
            try
            {
                _doc.Load(@".\.\.\XML_Files\ModulList.xml");
            }

            //When the File wasnt Found or a error is in the File a MessageBox will apear and the Programm will be stopped
            catch (Exception ex)
            {
                //When the XML wasnt found this MesassgeBox will show up
                if (ex is System.IO.FileNotFoundException)
                {
                    MessageBox.Show("XML File 'ModulList' not Found. Please Contact Support.",
                        "XML File not Found");
                }

                //and when there is an error in the File this Box will show up
                if (ex is XmlException)
                {
                    MessageBox.Show("Error in XML File 'ModulList'",
                        "Error in XML File");
                }

                //At the End the programm will be stoped
                Environment.Exit(0);
            }
            #endregion

            #region Read and Save all the Node with PSM information
            try
            {
                //Read the Text inside the Node section
                foreach (XmlNode node in _doc.DocumentElement.SelectSingleNode("/Modullist/Modules/Nodes_with_PSM12ex"))
                {
                    //Here the information about the Node is read and saved
                    Nodes newnode = new Nodes(
                        node.Attributes["Name"]?.InnerText,
                        Convert.ToInt32(node.Attributes["Artnr"]?.InnerText),
                        Convert.ToInt32(node.Attributes["Maxpowerextbus_mw"]?.InnerText),
                        node.Attributes["MAS"]?.InnerText,
                        Convert.ToInt32(node.Attributes["Maxmodulecount"]?.InnerText)
                        );

                    //Add the Nodes to the Combobox

                    Nodes.Add(node.Attributes["Name"]?.InnerText, newnode);

                    _pcvm.AddnodesPsm(newnode.Name, newnode);
                }
            }

            //When an error apears while the XMl is readout a Message box will show up and the Programm will be stoped.
            catch (/*NullReferenceException*/XmlException)
            {
                MessageBox.Show("Error in XML File 'ModulList'", "Error in XML File");

                Environment.Exit(0);
            }
            #endregion
        }
    }
}
