﻿#region using Directives
using System;
using System.Xml;
using System.Windows;
using System.Collections.Generic;
using Selectron_C_Bus_Calculator.ViewModel;
#endregion

namespace Selectron_C_Bus_Calculator.Model
{
    class create_extension_dictionary
    {
        #region Varibles
        //This Public Dictionary is for saving all the Extension Names and data
        public Dictionary<string, Extensions> Extmodules = new Dictionary<string, Extensions>();

        //This List will be displayed in the Node Combobox
        public List<string> NodeKey = new List<string>();
        #endregion

        #region Instances
        //Initialise other Classes
        readonly XmlDocument _doc = new XmlDocument();
        #endregion

        public Dictionary<string, Extensions> CreateExtensionDictionary(string nodename)
        {
            #region Load Xml File
            nodename = nodename.Replace(" ", "_");
            nodename = nodename.Replace("/", "_");

            //Try to Load the XML File 
            try
            {
                _doc.Load(@".\.\.\XML_Files\ModulList.xml");
            }
            //When the File wasnt Found or a error is in the File a MessageBox will apear and the Programm will be stopped
            catch (Exception ex)
            {
                //When the XML wasnt found this MesassgeBox will show up
                if (ex is System.IO.FileNotFoundException)
                {
                    MessageBox.Show("XML File 'ModulList' not Found. Please Contact Support.",
                        "XML File not Found");
                }

                //and when there is an error in the File this Box will show up
                if (ex is XmlException)
                {
                    MessageBox.Show("Error in XML File 'ModulList'",
                        "Error in XML File");
                }

                //At the End the programm will be stoped
                Environment.Exit(0);
            }
            #endregion

            #region Load the infomations of the Xml File
            foreach (XmlNode extension in _doc.DocumentElement.SelectSingleNode("/Modullist/Modules/Extensions/" + nodename))
            {
                Extensions newextensions = new Extensions(
                    extension.Attributes["Name"]?.InnerText,
                    Convert.ToInt32(extension.Attributes["Artnr"]?.InnerText),
                    Convert.ToInt32(extension.Attributes["Powerextbus_mw"]?.InnerText),
                    Convert.ToInt32(extension.Attributes["Maxmoduleonnode"]?.InnerText)
                    );

                if(newextensions.Maxmoduleonnode != 0 && newextensions.Powerextbus_mw != 0 && newextensions.Artnr != 0 && newextensions.Name != "")
                { 
                    Extmodules.Add(extension.Attributes["Name"]?.InnerText, newextensions);
                }
            }
            #endregion

            return Extmodules;
        }
    }
}
