﻿#region using Directives
using System;
using System.Windows;
using System.Windows.Controls;
using System.Collections.Generic;
using Selectron_C_Bus_Calculator.Model;
using Selectron_C_Bus_Calculator.ViewModel;
#endregion

namespace Selectron_C_Bus_Calculator.View
{
    /// <summary>
    /// Interaktionslogik für Extension.xaml
    /// </summary>
    public partial class ExtensionView : UserControl
    {
        #region Variables
        //These are all Varibles the this Document uses
        private int maxmodule;
        private int modulecount;
        private bool Flag = false;
        private int oldchosennumber;
        private int chosenmodulenumber;
        private string chosenextension;
        #endregion

        #region Instances
        //These are all Objects the this Document uses
        private ExtensionViewModel extensionViewModel;
        private PowerCalculatorViewModel powerCalculationViewModel;
        private Dictionary<string, Extensions> extensionInfo = new Dictionary<string, Extensions>();
        private create_extension_dictionary CreateExtensionDictionary = new create_extension_dictionary();
        #endregion

        public ExtensionView()
        {
            InitializeComponent();
        }

        private void Extension_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                //In this ViewModel all informations about the extensions are saved
                extensionInfo = PowerCalculatorViewModel.getextensions;

                //When an extension is chosen a new Usercontroll is created
                extensionViewModel = new ExtensionViewModel(false, false, extensionInfo);

                //Get the saved ViewModel
                powerCalculationViewModel = SaveandGetViewModel.powerCalculationViewModel;

                //Here the chosen extension is readout
                chosenextension = Extension.SelectedValue.ToString();

                //Adds the chosen extension to a Dictionary in the PowerCalculationViewModel
                powerCalculationViewModel.UsedExtenions(chosenextension);

                //Here the Max count of modules on Node is saved
                maxmodule = extensionInfo[chosenextension].Maxmoduleonnode;

                //The Count Count Combobox is cleared
                Number.Items.Clear();

                #region Add Items to Count
                //Here the Numbers are added to the Count Combobox
                for (int i = 0; i < maxmodule; i++)
                {
                    Number.Items.Add((i) + 1);
                }
                #endregion

                //Then the Count Combobox is enabled
                Number.IsEnabled = true;
            }

            catch(NullReferenceException)
            {  
            }
        }

        private void Number_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Readout how much Modules are chosen
            chosenmodulenumber = Convert.ToUInt16(Number.SelectedValue);

            #region Change content for the ListviewInformation
            //When the old chosennumber is smaller than the new one then write this in the listview
            if (oldchosennumber <= chosenmodulenumber)
            {
                modulecount = chosenmodulenumber - oldchosennumber;
            }

            //When the old chosennumber is bigger than the new one then write this in the listview
            else if (oldchosennumber > chosenmodulenumber)
            {
                modulecount = chosenmodulenumber - oldchosennumber;
            }
            #endregion

            //Change the content of the oldchosennumber
            oldchosennumber = chosenmodulenumber;
            //Save the processed extension Dictionary
            powerCalculationViewModel.ReceiveExtensions(extensionInfo);
            //Change the Listview Content
            powerCalculationViewModel.ListViewInfo(extensionInfo[chosenextension].Powerextbus_mw, modulecount);

            #region Add new Usercontroll in the ObservableCollection
            if (Flag == false)
            {
                powerCalculationViewModel.AddUserControl(true,false);
            }
            Flag = true;
            #endregion
        }
    }
}
