﻿#region using Directives
//These are all Directives this Document uses
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using Selectron_C_Bus_Calculator.ViewModel;
using Selectron_C_Bus_Calculator.Model;
using System.Reflection;
using System.Windows.Data;
using System.Globalization;
#endregion

namespace Selectron_C_Bus_Calculator.View
{
    /// <summary>
    /// Interaktionslogik für PowerCalculatorView.xaml
    /// </summary>
    public partial class PowerCalculatorView : Window
    {
        #region Variables
        //This are the Variables this Document uses
        #endregion

        #region Instances
        //This are all Objects wich are used in this Document
        private Startup start = new Startup();
        private ExtensionView extensionView = new ExtensionView();
        private PowerCalculatorViewModel viewModel = new PowerCalculatorViewModel();
        private create_extension_dictionary createextdic = new create_extension_dictionary();
        public Dictionary<string, Extensions> extensions = new Dictionary<string, ViewModel.Extensions>();
        #endregion

        public PowerCalculatorView()
        {
            InitializeComponent();

            this.DataContext = viewModel;

            //Here the Informations about the Nodes are readout
            viewModel.startup(viewModel);

            #region Assembly
            var executingAssembly = Assembly.GetExecutingAssembly(); //MyLibrary.dll
            var callingAssembly = Assembly.GetCallingAssembly(); //MyLibrary.dll
            var entryAssembly = Assembly.GetEntryAssembly(); //WpfApp.exe or MyLibrary.dll
            #endregion

            #region Executable location
            var wpfAssembly = (AppDomain.CurrentDomain
                .GetAssemblies()
                .Where(item => item.EntryPoint != null)
                .Select(item =>
                    new { item, applicationType = item.GetType(item.GetName().Name + ".App", false) })
                .Where(a => a.applicationType != null && typeof(System.Windows.Application)
                    .IsAssignableFrom(a.applicationType))
                    .Select(a => a.item))
            .FirstOrDefault();

            var location = wpfAssembly.Location;
            #endregion

            #region Link editing
            //Here the Executable Location is edited in order to get the icon Link
            string backslash = @"\";

            char[] backslashchararray = backslash.ToCharArray();

            location = location.Replace(backslashchararray[0], '/');

            string[] locationpart = location.Split(new char[] {'/'});

            string link = (locationpart[0] + "/" +
                locationpart[1] + "/" +
                locationpart[2] + "/" +
                locationpart[3] + "/" +
                locationpart[4] + "/" +
                locationpart[5] + "/" +
                locationpart[6] + "/" +
                locationpart[7] + "/" +
                locationpart[8] + "/" +
                locationpart[9]) + "/images/warn.ico";
            #endregion

            #region Warning icon
            //The Source for the Warning icon is set
            warnmodule.Source = (ImageSource)new ImageSourceConverter().ConvertFromString(link);
            warnpower.Source = (ImageSource)new ImageSourceConverter().ConvertFromString(link);
            #endregion
        }

        #region Node Section/ Startup Section
        private void Node_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            
            //Get the Selected Node
            viewModel.GetNode();
            //Clear the Collection of Usercontrolls
            viewModel.ClearObservableCollection();
            //Delete all the Items in the Dictionary
            viewModel.ClearDictionary();
            //Add a new Usercontroll
            viewModel.AddUserControl(true, false);
            //Save this ViewModel in a static Class
            viewModel.SavePowerCalculationViewModel(viewModel);
            //Enter the Startinformations in the Listboxes
            viewModel.StartInfo();

            PSM.IsChecked = false;
            PSM6Ex.IsChecked = false;
        }

        private void PSM_Checked(object sender, RoutedEventArgs e)
        {
            //When the User checks the Box the Informations about the Nodes wich can use PSM

            //Here the Informations about the Nodes are readout
            viewModel.startupPsm(viewModel);
            //Get the Selected Node
            viewModel.GetNodePsm();
            //Clear the Collection of Usercontrolls
            viewModel.ClearObservableCollection();
            //Delete all the Items in the Dictionary
            viewModel.ClearDictionary();
            //Add a new Usercontroll
            viewModel.AddUserControl(true, false);
            //Save this ViewModel in a static Class
            viewModel.SavePowerCalculationViewModel(viewModel);
            //Enter the Startinformations in the Listboxes
            viewModel.StartInfoPsm();
        }

        private void PSM_UnChecked(object sender, RoutedEventArgs e)
        {
            //When the PSM Box is unchecked the Informations about the Normal Nodes are readout

            //Get the Selected Node
            viewModel.GetNode();
            //Clear the Collection of Usercontrolls
            viewModel.ClearObservableCollection();
            //Delete all the Items in the Dictionary
            viewModel.ClearDictionary();
            //Add a new Usercontroll
            viewModel.AddUserControl(true, false);
            //Save this ViewModel in a static Class
            viewModel.SavePowerCalculationViewModel(viewModel);
            //Enter the Startinformations in the Listboxes
            viewModel.StartInfo();
        }

        private void PSM6Ex_Checked(object sender, RoutedEventArgs e)
        {
            //When the User checks the Box the Informations about the Nodes wich can use PSM

            //Here the Informations about the Nodes are readout
            viewModel.startupPsm6Ex(viewModel);
            //Get the Selected Node
            viewModel.GetNodePsm();
            //Clear the Collection of Usercontrolls
            viewModel.ClearObservableCollection();
            //Delete all the Items in the Dictionary
            viewModel.ClearDictionary();
            //Add a new Usercontroll
            viewModel.AddUserControl(true, false);
            //Save this ViewModel in a static Class
            viewModel.SavePowerCalculationViewModel(viewModel);
            //Enter the Startinformations in the Listboxes
            viewModel.StartInfoPsm();
        }
        #endregion

    }
}
