﻿using System;
using System.ComponentModel;

namespace Selectron_C_Bus_Calculator.ViewModel
{
    public abstract class BaseViewModel : INotifyPropertyChanged
    {
        #region RaisePropertyChanged
        //When an information, wich is bound to the PowerCalculationView, is updated the PowerCalculationView is also updated.
        public event PropertyChangedEventHandler PropertyChanged;
        private PowerCalculatorViewModel powerCalulatorViewModel;
        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) 
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
