﻿#region using Directives
using System;
using System.Windows;
using System.Windows.Media;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Selectron_C_Bus_Calculator.Model;
#endregion


namespace Selectron_C_Bus_Calculator.ViewModel
{
    public class PowerCalculatorViewModel : BaseViewModel
    {
        #region Variables
        private int rempower;
        private int remmodule;
        private string getnode;
        private int Powercount;
        private int Modulecount;
        private ImageSource imgsource;
        private Visibility visibility;
        private static string chosennode;
        private ObservableCollection<FillNode> NodeList;
        private List<string> usedExtensions = new List<string>();
        private ObservableCollection<ExtensionViewModel> extensions;
        private Brush bgColor;
        private Dictionary<string, Nodes> nodeinfos = new Dictionary<string, Nodes>();
        private Dictionary<string, Extensions> extension = new Dictionary<string, ViewModel.Extensions>();
        private ObservableCollection<FillListViewViewModel> list = new ObservableCollection<FillListViewViewModel>();
        public static Dictionary<string, Extensions> getextensions = new Dictionary<string, ViewModel.Extensions>();
        #endregion

        #region Instances
        private FillNode node;
        private Startup start;
        private StartupPsm6Ex _startupPsm6Ex;
        private StartupPsm12Ex startPsm;
        private create_extension_dictionary CreateExtensionDictionary;
        private NameToBackgroundConverter ColorConvert;
        #endregion

        #region Constructor
        public PowerCalculatorViewModel()
        {
            Visibility = Visibility.Hidden;
            Visibility6Ex = Visibility.Hidden;
            extensions = new ObservableCollection<ExtensionViewModel>();
            NodeList = new ObservableCollection<FillNode>();
            Extensions.Add(new ExtensionViewModel(false, false, extension));
        }
        #endregion

        #region Properties
        public ObservableCollection<ExtensionViewModel> Extensions
        {
            get
            {
                return extensions;
            }

            set
            {
                extensions = value;
                RaisePropertyChanged("Extensions");
            }
        }

        public ObservableCollection<FillNode> FillNodes
        {
            get
            {
                return NodeList;
            }

            set
            {
                NodeList = value;
                RaisePropertyChanged("FillNodes");
            }
        }

        public FillNode ChosenNode
        {
            get
            {
                return node;
            }
            set
            {
                node = value;
                RaisePropertyChanged("ChosenNode");
            }
        }

        public ObservableCollection<FillListViewViewModel> fillListView
        {
            get
            {
                return list;
            }
            set
            {
                list = value;
                RaisePropertyChanged("fillListView");
            }
        }

        public ImageSource imgSource
        {
            get
            {
                return imgsource;
            }
            set
            {
                imgsource = value;
                RaisePropertyChanged("imgSource");
            }
        }

        public Visibility Visibility
        {
            get
            {
                return visibility;
            }

            set
            {
                visibility = value;
                RaisePropertyChanged("Visibility");
            }
        }

        public Visibility Visibility6Ex
        {
            get
            {
                return visibility;
            }

            set
            {
                visibility = value;
                RaisePropertyChanged("Visibility6Ex");
            }
        }

        public Visibility countVisibility
        {
            get
            {
                return visibility;
            }
            set
            {
                visibility = value;
                RaisePropertyChanged("countVisibility");
            }
        }

        public Visibility powerVisibility
        {
            get
            {
                return visibility;
            }
            set
            {
                visibility = value;
                RaisePropertyChanged("powerVisibility");
            }
        }

        public Brush BGColor
        {
            get
            {
                return bgColor;
            }
            set
            {
                bgColor = value;
                RaisePropertyChanged("BGColor");
            }
        }
        #endregion

        #region Methods
        public void AddUserControl(bool isenabled, bool isenabled_number)
        {
            //Add new UserControll
            try
            {
                extension = GetExtensions(chosennode);
            }
            catch(NullReferenceException)
            {

            }
            getextensions = extension;

            if(Extensions.Count < 12)
            { 
                Extensions.Add(new ExtensionViewModel(isenabled, isenabled_number, extension));
            }
        }

        public void ClearObservableCollection()
        {
            //Clear the UserControll ObservableCollection
            Extensions.Clear();
        }

        public void ClearDictionary()
        {
            //Clear the UserControll Dictionary
            extensions.Clear();
        }

        public void AddNodes(string node, Nodes nodes)
        {
            //Add the Nodes to the Dictionary
            FillNodes.Add(new FillNode(node));
            nodeinfos.Add(node, nodes);
        }

        public void AddnodesPsm(string node, Nodes nodes)
        {
            //Add the PSM Nodes to the Dictionary
            nodeinfos.Add(node, nodes);
        }

        public void clearnodeinfos()
        {
            //Clear the Node Dictionary
            FillNodes.Clear();
            nodeinfos.Clear();
        }
         
        public void GetNode()
        {
            //Get the chosen Node
            getnode = ChosenNode.Node;
            chosennode = getnode;

            if(chosennode == "CPU 831-TG" || chosennode == "CPU 833-TG")
            {
                Visibility = Visibility.Visible;
                Visibility6Ex = Visibility.Visible;
                
            }
            else
            {
                Visibility6Ex = Visibility.Hidden;
                Visibility = Visibility.Hidden;
            }
        }

        public void GetNodePsm()
        {
            //Get the Chosen Node when the PSM Box is checked
            chosennode = getnode + " PSM"; 
        }

        public void ReceiveExtensions (Dictionary<string, Extensions> extension)
        {
            //Get the Extension Dictionary of this object
            this.extension = extension;
        }

        public Dictionary<string, Extensions> GetExtensions(string chosennode)
        {
            //Create new extension Dictionary and fill it
            CreateExtensionDictionary = new create_extension_dictionary();
            extension = CreateExtensionDictionary.CreateExtensionDictionary(chosennode);

            return extension;
        }

        public void startup (PowerCalculatorViewModel powerCalculationViewModel)
        {
            //Give this object to the Startup Model and get all needed information
            start = new Startup();
            start.startup(powerCalculationViewModel);
        }

        public void startupPsm(PowerCalculatorViewModel powerCalculationViewModel)
        {
            //Give this object to the StartupPSM Model and get all needed information
            startPsm = new StartupPsm12Ex();
            startPsm.Startup(powerCalculationViewModel);
            Visibility6Ex = Visibility.Hidden;
        }

        public void startupPsm6Ex(PowerCalculatorViewModel powerCalculationViewModel)
        {
            //Give this object to the StartupPSM Model and get all needed information
            _startupPsm6Ex = new StartupPsm6Ex();
            _startupPsm6Ex.Startup(powerCalculationViewModel);
            Visibility = Visibility.Hidden;
        }

        public void SavePowerCalculationViewModel(PowerCalculatorViewModel viewModel)
        {
            //Save this object
            SaveandGetViewModel.powerCalculationViewModel = viewModel;
        }

        public void StartInfo()
        {
            //This is the information wich is from the start in the listview
            Modulecount = 0;
            remmodule = 0;
            Powercount = 0;
            rempower = 0;
            nodeinfos.Remove("CPU 831-TG PSM");
            nodeinfos.Remove("CPU 833-TG PSM");
            FillListView(nodeinfos[chosennode].Maxmodulecount, 0, nodeinfos[chosennode].Maxpowerextbus_mw, 0);
        }

        public void StartInfoPsm()
        {
            //This is the information wich is from the start in the listview
            Modulecount = 0;
            remmodule = 0;
            Powercount = 0;
            rempower = 0;
            FillListView(nodeinfos[chosennode].Maxmodulecount, 0, nodeinfos[chosennode].Maxpowerextbus_mw, 0);
        }

        public void ListViewInfo (int extpower, int count)
        {
            //This is the information wich is show in the Listview
            int totalpower;
            totalpower = extpower * count;
            Modulecount += count;
            remmodule = nodeinfos[chosennode].Maxmodulecount - Modulecount;
            Powercount += (extpower * count);
            rempower = nodeinfos[chosennode].Maxpowerextbus_mw - Powercount;

            FillListView(remmodule, Modulecount, rempower, Powercount);

            if(remmodule < 0)
            { 
                BGColor = new SolidColorBrush(Colors.Red);
                countVisibility = Visibility.Visible;
                MessageBox.Show("Maximal Module number exceeded");             
            }

            if (rempower < 0)
            {
                powerVisibility = Visibility.Visible;
                MessageBox.Show("Maximal Module power exceeded");
            }
        }

        public void FillListView (int remModule, int modulecnt, int remPower, int powercnt)
        {
            //Fill the new information in the Listview
            list.Clear();
            list.Add(new FillListViewViewModel(remModule, modulecnt, remPower, powercnt));
        } 

        public void UsedExtenions (string usedextension)
        {
            //Add the used extensions in the usedExtensions Dictionary
            usedExtensions.Add(usedextension);
        }
        #endregion
    }
}
